2 # Library code for git p4 tests
5 # p4 tests never use the top-level repo; always build/clone into
6 # a subdirectory called "$git"
7 TEST_NO_CREATE_REPO
=NoThanks
9 # Some operations require multiple attempts to be successful. Define
10 # here the maximal retry timeout in seconds.
13 # Sometimes p4d seems to hang. Terminate the p4d process automatically after
14 # the defined timeout in seconds.
19 if ! test_have_prereq PYTHON
21 skip_all
='skipping git p4 tests; python not available'
24 ( p4
-h && p4d
-h ) >/dev
/null
2>&1 ||
{
25 skip_all
='skipping git p4 tests; no p4 or p4d'
29 # On cygwin, the NT version of Perforce can be used. When giving
30 # it paths, either on the command-line or in client specifications,
31 # be sure to use the native windows form.
33 # Older versions of perforce were available compiled natively for
34 # cygwin. Those do not accept native windows paths, so make sure
35 # not to convert for them.
38 if test_have_prereq CYGWIN
&& ! p4
-V |
grep -q CYGWIN
40 path
=$
(cygpath
--windows "$path")
42 path
=$
(test-tool path-utils real_path
"$path")
47 # On Solaris the 'date +%s' function is not supported and therefore we
48 # need this replacement.
49 # Attention: This function is not safe again against time offset updates
50 # at runtime (e.g. via NTP). The 'clock_gettime(CLOCK_MONOTONIC)'
51 # function could fix that but it is not in Python until 3.3.
53 (cd / && "$PYTHON_PATH" -c 'import time; print(int(time.time()))')
58 P4PORT
=localhost
:$P4DPORT
63 export P4PORT P4CLIENT P4USER P4EDITOR P4CHARSET
65 db
="$TRASH_DIRECTORY/db"
66 cli
="$TRASH_DIRECTORY/cli"
67 git
="$TRASH_DIRECTORY/git"
68 pidfile
="$TRASH_DIRECTORY/p4d.pid"
70 # Sometimes "prove" seems to hang on exit because p4d is still running
74 kill -9 $
(cat "$pidfile") 2>/dev
/null
&& exit 255
79 # git p4 submit generates a temp file, which will
80 # not get cleaned up if the submission fails. Don't
81 # clutter up /tmp on the test machine.
82 TMPDIR
="$TRASH_DIRECTORY"
86 mkdir
-p "$db" "$cli" "$git" &&
91 p4d
-q -p $P4DPORT "$@" &
96 # This gives p4d a long time to start up, as it can be
97 # quite slow depending on the machine. Set this environment
98 # variable to something smaller to fail faster in, say,
99 # an automated test setup. If the p4d process dies, that
100 # will be caught with the "kill -0" check below.
101 i
=${P4D_START_PATIENCE:-300}
102 pid
=$
(cat "$pidfile")
104 timeout
=$
(($
(time_in_seconds
) + $P4D_TIMEOUT))
107 if test $
(time_in_seconds
) -gt $timeout
119 # succeed when p4 client commands start to work
120 if p4 info
>/dev
/null
2>&1
126 kill -0 $pid 2>/dev
/null ||
break
127 echo waiting
for p4d to start
134 # p4d failed to start
138 # build a p4 user so author@example.com has an entry
142 client_view
"//depot/... //client/..." &&
151 Email: $name@example.com
165 retry_until_success
() {
166 timeout
=$
(($
(time_in_seconds
) + $RETRY_TIMEOUT))
167 until "$@" 2>/dev
/null ||
test $
(time_in_seconds
) -gt $timeout
173 retry_until_fail
() {
174 timeout
=$
(($
(time_in_seconds
) + $RETRY_TIMEOUT))
175 until ! "$@" 2>/dev
/null ||
test $
(time_in_seconds
) -gt $timeout
182 pid
=$
(cat "$pidfile")
183 retry_until_fail
kill $pid
184 retry_until_fail
kill -9 $pid
185 # complain if it would not die
186 test_must_fail
kill $pid >/dev
/null
2>&1 &&
187 rm -rf "$db" "$cli" "$pidfile" &&
188 retry_until_fail
kill -9 $watchdog_pid
192 retry_until_success
rm -r "$git"
193 test_must_fail
test -d "$git" &&
194 retry_until_success mkdir
"$git"
200 cat >"$TRASH_DIRECTORY/marshal-dump.py" <<-EOF &&
203 instream = getattr(sys.stdin, 'buffer', sys.stdin)
204 for i in range($line):
205 d = marshal.load(instream)
206 print(d[b'$what'].decode('utf-8'))
208 "$PYTHON_PATH" "$TRASH_DIRECTORY/marshal-dump.py"
212 # Construct a client with this list of View lines
218 Description: $P4CLIENT
220 AltRoots: $(native_path "$cli")
228 is_cli_file_writeable
() {
229 # cygwin version of p4 does not set read-only attr,
230 # will be marked 444 but -w is true
232 if test_have_prereq CYGWIN
&& p4
-V |
grep -q CYGWIN
234 stat
=$
(stat
--format=%a
"$file") &&